# 4.0.7 Release Notes

## Improvements

*	Improved error location reporting
*	Allow [] as a dictionary value, resolves antlr/stringtemplate4#33
*	Several STViz updates: 
 *	  Highlight template subexpressions and literal text responsible for output
 *	  Gray out hidden (inherited+aliased) attributes
 *	  Highlight user-instanced templates in bold

## Bug fixes

*	Escapes: `>\>` means `>>` inside of `<<...>>`.
*	Escapes: `\>>` means `>>` inside of `<<...>>` unless at end like `<<...\>>>>`.  In that case, use `<%..>>%>` instead.
*	Added warning about: "Missing newline after newline escape <\\>"
*	`%\>` is the escape to avoid end of string
*	Fix issues with bytecode to source mapping
*	Fix several STViz bugs
*	Fix several unit tests
*	Explicit InstanceScope tracking in the interpreter
*	throw exceptionWhen the attribute name is no to be consistent with the
*	  other check for '.' in the name.
*	Allow [] as a default value for formal arguments (fixes antlr/stringtemplate4#20)
*	Add method STViz.waitForClose()
*	Specify -Dtest.interactive to have STViz tests leave the window open for the user
*	Don't cache the STNoSuchPropertyException and STNoSuchAttributeException instances.
*	Add ErrorType.NO_SUCH_ATTRIBUTE_PASS_THROUGH, reported on <foo(...)> where foo contains a parameter with no default value and no matching attribute exists in the surrounding scope.
*	Improved message when reporting ErrorType.NO_SUCH_PROPERTY.
*	DateRenderer and StringRenderer now use the provided locale (fixes antlr/stringtemplate4#11)
*	Fixes for handling of arrays (fixes antlr/stringtemplate4#12 and other unreported issues)
*	Try to load template file (.st) if group file (.stg) failed with IOException (fixes antlr/stringtemplate4#14)
*	Add STGroup.GROUP_FILE_EXTENSION and STGroup.TEMPLATE_FILE_EXTENSION
*	Updated documentation, code cleanup
